/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.cepportal.backend;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.xml.XMLConstants;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.myfaces.custom.fileupload.UploadedFile;
import org.w3c.dom.Document;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 * This class contains some useful methods for converting XML documents and validation
 * 
 * @author Štefan Repček
 */
public class BackendHelpers {
    
    
    private final static Log log = LogFactory.getLog(BackendHelpers.class);
    
    
    
    
    public static void validateXSD(Document xml) throws SAXException, IOException
    {
        
            String language = XMLConstants.W3C_XML_SCHEMA_NS_URI;
            SchemaFactory factory = SchemaFactory.newInstance(language);
            InputStream s = BackendHelpers.class.getResourceAsStream("/XMLSchema.xsd");
            Schema schema = factory.newSchema(new StreamSource(s));
            Validator validator = schema.newValidator();
            
            validator.validate(new DOMSource(xml));
            
    
 
        
    }
    
    
    public static Document fileToXMLDocument(UploadedFile file) {
        try {
            InputStream s = file.getInputStream();

            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      
            DocumentBuilder builder;
         


            builder = factory.newDocumentBuilder();
            Document xml = builder.parse(s);

            return xml;




        } catch (IOException ex) {
            log.error(ex);
        } catch (ParserConfigurationException ex) {
            log.error(ex);
        } catch (SAXException ex) {
            log.error(ex);
        }
        return null;
    }

    public static String xmlDocToString(Document xml) {
        DOMImplementationLS domImplementation = (DOMImplementationLS) xml.getImplementation();
        LSSerializer lsSerializer = domImplementation.createLSSerializer();
        String stringEvent = lsSerializer.writeToString(xml);
        return stringEvent;
    }
    
     public static Document xmlStringToDoc(String xmlString) {
        try {
            InputSource s = new InputSource(new StringReader(xmlString));
            DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();

            return builderFactory.newDocumentBuilder().parse(s);
        } catch (SAXException ex) {
            log.error(ex);
        } catch (IOException ex) {
            log.error(ex);
        } catch (ParserConfigurationException ex) {
            log.error(ex);
        }
            return null;
    }
     
    public static boolean validateEventType(String scheme, String rootElementName, String name)
    {
        if ("".equals(name)) {
            sendFacesMessage("event", "event type name cannot be empty");
            return false;
        }
        if ("".equals(rootElementName)) {
            sendFacesMessage("event", "event type root element name cannot be empty");
            return false;
        }
         if ("".equals(scheme)) {
            sendFacesMessage("event", "event type XML scheme cannot be empty");
            return false;
        }
        
        return true;
        
    }
    
    public static boolean validateEPLStatement(String expression, String statementName)
    {
        if ("".equals(statementName)) {
            sendFacesMessage("eplStatement", "statement name cannot be empty");
            return false;
        }
        if ("".equals(expression)) {
            sendFacesMessage("eplStatement", "statement expression cannot be empty");
            return false;
        }
        
        return true;
    }
    public static void sendFacesMessage(String component, String msg)
    {
        FacesContext context = FacesContext.getCurrentInstance();
        context.addMessage(component,new FacesMessage(msg));
       
    } 
    
}
