/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.cepportal.backend;

import cz.muni.fi.cepportal.database.dto.CEPOutputDTO;
import cz.muni.fi.cepportal.database.exceptions.NonexistentEntityException;
import cz.muni.fi.cepportal.database.services.CEPOutputService;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import javax.annotation.PostConstruct;
import javax.faces.context.FacesContext;
import javax.inject.Named;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;

/**
 * Managed Bean for CEPOutput entity.  
 * 
 * @author Štefan Repček
 */
@Named("cepOutputManagedBean")
@Scope("session")
public class CEPOutputManagedBean implements Serializable{
    
   @Autowired
   private CEPOutputService cepOutputService;
    
   
  private final static Log log = LogFactory.getLog(CEPOutputManagedBean.class);
  
  private List<CEPOutputDTO> cepOutputs = new ArrayList<CEPOutputDTO>();
  
  private CEPOutputDTO cepOutput = new CEPOutputDTO();
  private String cepOutputNameToEdit;

    public String getCepOutputNameToEdit() {
        return cepOutputNameToEdit;
    }

    public void setCepOutputNameToEdit(String cepOutputNameToEdit) {
        this.cepOutputNameToEdit = cepOutputNameToEdit;
    }

    public List<CEPOutputDTO> getCepOutputs() {
        return cepOutputs;
    }

    public void setCepOutputs(List<CEPOutputDTO> cepOutputs) {
        this.cepOutputs = cepOutputs;
    }

    public CEPOutputDTO getCepOutput() {
        return cepOutput;
    }

    public void setCepOutput(CEPOutputDTO cepOutput) {
        this.cepOutput = cepOutput;
    }
    
    @PostConstruct
    public void init()
    {
        this.cepOutputs = cepOutputService.findAllCEPOutputs();
    }
    
    public void add(String output)
    {   
        cepOutput.setId(null);
        cepOutput.setCepOutput(output);
        cepOutputService.createCEPOutput(cepOutput);
        init();
    }
    
    public void edit()
    {   
        
        Map<String,String> params = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap();
        cepOutput = cepOutputService.getCEPOutputByID(Long.parseLong(params.get("id")));
        cepOutput.setName(cepOutputNameToEdit);
        cepOutputService.updateCEPOutput(cepOutput);
        log.info("output edited");
        init();
    }
    public void delete() throws NonexistentEntityException
    {
         Map<String,String> params = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap();
         CEPOutputDTO cepOutputToDelete = cepOutputService.getCEPOutputByID(Long.parseLong(params.get("id")));
        cepOutputService.deleteCEPOutput(cepOutputToDelete);
        init();
    }
    
    public void select()
    {
        Map<String,String> params = FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap();

        cepOutput = cepOutputService.getCEPOutputByID(Long.parseLong(params.get("id")));
    }
    
    
            
  
   
}
