/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.cepportal.backend;

import java.io.Serializable;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


import org.primefaces.push.PushContext;
import org.primefaces.push.PushContextFactory;

/**
 * This class represents Listener, which catches response messages from server and prints it to 
 * user interface via primefaces push technology.
 * 
 * @author Štefan Repček
 */
public class ResponseMessageListener implements MessageListener,Serializable {

    private static Log log = LogFactory.getLog(ResponseMessageListener.class);
    private StringBuilder response= new StringBuilder();
    


    
    public StringBuilder getResponse() {
        return response;
    }

    public void setResponse(StringBuilder response) {
        this.response = response;
    }
    
    
    
    public void clear()
    {
        response=new StringBuilder();
    }

  
    
    
    @Override
    public void onMessage(Message msg) {
        TextMessage message = (TextMessage) msg;
        try {
            response.append(message.getText()).append("\n");
          try {
                Thread.sleep(250); // without this ugly thread sleep server push does not work properly :/
            } catch (InterruptedException ex) {
                log.error(ex);
            } 
            PushContext pushContext =  PushContextFactory.getDefault().getPushContext();
            pushContext.push("/cepportal",response.toString()); 
        
            System.out.println("get message " + message.getText() );
        } catch (JMSException ex) {
            log.error(ex);
        }
    }
    
}
